<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelAdditionalElement1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelAdditionalElement1 extends AbstractStructArrayBase
{
    /**
     * The HotelOffer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelAdditionalElement[]
     */
    public $HotelOffer;
    /**
     * Constructor method for ArrayOfJP_HotelAdditionalElement1
     * @uses ArrayOfJP_HotelAdditionalElement1::setHotelOffer()
     * @param \StructType\JP_HotelAdditionalElement[] $hotelOffer
     */
    public function __construct(array $hotelOffer = array())
    {
        $this
            ->setHotelOffer($hotelOffer);
    }
    /**
     * Get HotelOffer value
     * @return \StructType\JP_HotelAdditionalElement[]|null
     */
    public function getHotelOffer()
    {
        return $this->HotelOffer;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelOffer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelOffer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelOfferForArrayConstraintsFromSetHotelOffer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelAdditionalElement1HotelOfferItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelAdditionalElement1HotelOfferItem instanceof \StructType\JP_HotelAdditionalElement) {
                $invalidValues[] = is_object($arrayOfJP_HotelAdditionalElement1HotelOfferItem) ? get_class($arrayOfJP_HotelAdditionalElement1HotelOfferItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelAdditionalElement1HotelOfferItem), var_export($arrayOfJP_HotelAdditionalElement1HotelOfferItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelOffer property can only contain items of type \StructType\JP_HotelAdditionalElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelOffer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement[] $hotelOffer
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement1
     */
    public function setHotelOffer(array $hotelOffer = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelOfferArrayErrorMessage = self::validateHotelOfferForArrayConstraintsFromSetHotelOffer($hotelOffer))) {
            throw new \InvalidArgumentException($hotelOfferArrayErrorMessage, __LINE__);
        }
        $this->HotelOffer = $hotelOffer;
        return $this;
    }
    /**
     * Add item to HotelOffer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement1
     */
    public function addToHotelOffer(\StructType\JP_HotelAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The HotelOffer property can only contain items of type \StructType\JP_HotelAdditionalElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelOffer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelOffer
     */
    public function getAttributeName()
    {
        return 'HotelOffer';
    }
}
